<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>Property (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Property (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":6,"i12":9,"i13":10,"i14":6,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10,"i26":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/Property.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/property/Parent.html"
               title="interface in org.apache.poi.poifs.property"><span class="typeNameLink">Prev&nbsp;Class</span></a>
        </li>
        <li><a href="../../../../../org/apache/poi/poifs/property/PropertyConstants.html"
               title="interface in org.apache.poi.poifs.property"><span class="typeNameLink">Next&nbsp;Class</span></a>
        </li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/property/Property.html" target="_top">Frames</a>
        </li>
        <li><a href="Property.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.poifs.property</div>
    <h2 title="Class Property" class="title">Class Property</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.poifs.property.Property</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd><a href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                           title="interface in org.apache.poi.poifs.dev">POIFSViewable</a>, <a
                            href="../../../../../org/apache/poi/poifs/property/Child.html"
                            title="interface in org.apache.poi.poifs.property">Child</a></dd>
                </dl>
                <dl>
                    <dt>Direct Known Subclasses:</dt>
                    <dd><a href="../../../../../org/apache/poi/poifs/property/DirectoryProperty.html"
                           title="class in org.apache.poi.poifs.property">DirectoryProperty</a>, <a
                            href="../../../../../org/apache/poi/poifs/property/DocumentProperty.html"
                            title="class in org.apache.poi.poifs.property">DocumentProperty</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public abstract class <span class="typeNameLabel">Property</span>
extends java.lang.Object
implements <a href="../../../../../org/apache/poi/poifs/property/Child.html"
              title="interface in org.apache.poi.poifs.property">Child</a>, <a
                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                            title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></pre>
                <div class="block">This abstract base class is the ancestor of all classes
                    implementing POIFS Property behavior.
                </div>
                <dl>
                    <dt><span class="simpleTagLabel">Author:</span></dt>
                    <dd>Marc Johnson (mjohnson at apache dot org)</dd>
                </dl>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- =========== FIELD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.summary">
                        <!--   -->
                    </a>
                        <h3>Field Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Field Summary table, listing fields, and an explanation">
                            <caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Field and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected static int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#Z:Z_NO_INDEX">_NO_INDEX</a></span></code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colFirst"><code>protected static byte</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#Z:Z_NODE_BLACK">_NODE_BLACK</a></span></code>&nbsp;
                                </td>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected static byte</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#Z:Z_NODE_RED">_NODE_RED</a></span></code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier</th>
                                <th class="colLast" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected </code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#Property--">Property</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colFirst"><code>protected </code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#Property-int-byte:A-int-">Property</a></span>(int&nbsp;index,
                                    byte[]&nbsp;array,
                                    int&nbsp;offset)</code>
                                    <div class="block">Constructor from byte data</div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a
                                    href="javascript:show(4);">Abstract Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getChildIndex--">getChildIndex</a></span>()</code>
                                    <div class="block">Get the child property (its index in the Property Table)</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getIndex--">getIndex</a></span>()</code>
                                    <div class="block">get the index for this Property</div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getName--">getName</a></span>()</code>
                                    <div class="block">Get the name of this property</div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/property/Child.html"
                                        title="interface in org.apache.poi.poifs.property">Child</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getNextChild--">getNextChild</a></span>()</code>
                                    <div class="block">Get the next Child, if any</div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/property/Child.html"
                                        title="interface in org.apache.poi.poifs.property">Child</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getPreviousChild--">getPreviousChild</a></span>()</code>
                                    <div class="block">Get the previous Child, if any</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getShortDescription--">getShortDescription</a></span>()</code>
                                    <div class="block">Provides a short description of the object, to be used when a
                                        POIFSViewable object has not provided its contents.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getSize--">getSize</a></span>()</code>
                                    <div class="block">find out the document size</div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getStartBlock--">getStartBlock</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code><a href="../../../../../org/apache/poi/hpsf/ClassID.html"
                                                              title="class in org.apache.poi.hpsf">ClassID</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getStorageClsid--">getStorageClsid</a></span>()</code>
                                    <div class="block">Sets the storage clsid, which is the Class ID of a COM object
                                        which
                                        reads and writes this stream
                                    </div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>java.lang.Object[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getViewableArray--">getViewableArray</a></span>()</code>
                                    <div class="block">Get an array of objects, some of which may implement
                                        POIFSViewable
                                    </div>
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>java.util.Iterator&lt;java.lang.Object&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#getViewableIterator--">getViewableIterator</a></span>()</code>
                                    <div class="block">Get an Iterator of objects, some of which may implement
                                        POIFSViewable
                                    </div>
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>abstract boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#isDirectory--">isDirectory</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>static boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#isSmall-int-">isSmall</a></span>(int&nbsp;length)</code>
                                    <div class="block">does the length indicate a small document?</div>
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#preferArray--">preferArray</a></span>()</code>
                                    <div class="block">Give viewers a hint as to whether to call getViewableArray or
                                        getViewableIterator
                                    </div>
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>protected abstract void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#preWrite--">preWrite</a></span>()</code>
                                    <div class="block">Perform whatever activities need to be performed prior to
                                        writing
                                    </div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setChildProperty-int-">setChildProperty</a></span>(int&nbsp;child)</code>
                                    <div class="block">Set the child property.</div>
                                </td>
                            </tr>
                            <tr id="i16" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setIndex-int-">setIndex</a></span>(int&nbsp;index)</code>
                                    <div class="block">Set the index for this Property</div>
                                </td>
                            </tr>
                            <tr id="i17" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setName-java.lang.String-">setName</a></span>(java.lang.String&nbsp;name)</code>
                                    <div class="block">Set the name; silently truncates the name if it's too long.</div>
                                </td>
                            </tr>
                            <tr id="i18" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setNextChild-org.apache.poi.poifs.property.Child-">setNextChild</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/property/Child.html"
                                        title="interface in org.apache.poi.poifs.property">Child</a>&nbsp;child)</code>
                                    <div class="block">Set the next Child</div>
                                </td>
                            </tr>
                            <tr id="i19" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setNodeColor-byte-">setNodeColor</a></span>(byte&nbsp;nodeColor)</code>
                                    <div class="block">Set the node color.</div>
                                </td>
                            </tr>
                            <tr id="i20" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setPreviousChild-org.apache.poi.poifs.property.Child-">setPreviousChild</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/property/Child.html"
                                        title="interface in org.apache.poi.poifs.property">Child</a>&nbsp;child)</code>
                                    <div class="block">Set the previous Child</div>
                                </td>
                            </tr>
                            <tr id="i21" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setPropertyType-byte-">setPropertyType</a></span>(byte&nbsp;propertyType)</code>
                                    <div class="block">Set the property type.</div>
                                </td>
                            </tr>
                            <tr id="i22" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setSize-int-">setSize</a></span>(int&nbsp;size)</code>
                                    <div class="block">Set the size of the document associated with this Property</div>
                                </td>
                            </tr>
                            <tr id="i23" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setStartBlock-int-">setStartBlock</a></span>(int&nbsp;startBlock)</code>
                                    <div class="block">Set the start block for the document referred to by this
                                        Property.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i24" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#setStorageClsid-org.apache.poi.hpsf.ClassID-">setStorageClsid</a></span>(<a
                                        href="../../../../../org/apache/poi/hpsf/ClassID.html"
                                        title="class in org.apache.poi.hpsf">ClassID</a>&nbsp;clsidStorage)</code>
                                    <div class="block">Sets the storage class ID for this property stream.</div>
                                </td>
                            </tr>
                            <tr id="i25" class="rowColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#shouldUseSmallBlocks--">shouldUseSmallBlocks</a></span>()</code>
                                    <div class="block">Based on the currently defined size, should this property use
                                        small blocks?
                                    </div>
                                </td>
                            </tr>
                            <tr id="i26" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/property/Property.html#writeData-java.io.OutputStream-">writeData</a></span>(java.io.OutputStream&nbsp;stream)</code>
                                    <div class="block">Write the raw data to an OutputStream.</div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ FIELD DETAIL =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.detail">
                        <!--   -->
                    </a>
                        <h3>Field Detail</h3>
                        <a name="Z:Z_NO_INDEX">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>_NO_INDEX</h4>
                                <pre>protected static final&nbsp;int _NO_INDEX</pre>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../constant-values.html#org.apache.poi.poifs.property.Property._NO_INDEX">Constant
                                            Field Values</a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="Z:Z_NODE_BLACK">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>_NODE_BLACK</h4>
                                <pre>protected static final&nbsp;byte _NODE_BLACK</pre>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../constant-values.html#org.apache.poi.poifs.property.Property._NODE_BLACK">Constant
                                            Field Values</a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="Z:Z_NODE_RED">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>_NODE_RED</h4>
                                <pre>protected static final&nbsp;byte _NODE_RED</pre>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../constant-values.html#org.apache.poi.poifs.property.Property._NODE_RED">Constant
                                            Field Values</a></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="Property--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>Property</h4>
                                <pre>protected&nbsp;Property()</pre>
                            </li>
                        </ul>
                        <a name="Property-int-byte:A-int-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>Property</h4>
                                <pre>protected&nbsp;Property(int&nbsp;index,
                   byte[]&nbsp;array,
                   int&nbsp;offset)</pre>
                                <div class="block">Constructor from byte data</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>index</code> - index number</dd>
                                    <dd><code>array</code> - byte data</dd>
                                    <dd><code>offset</code> - offset into byte data</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="writeData-java.io.OutputStream-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>writeData</h4>
                                <pre>public&nbsp;void&nbsp;writeData(java.io.OutputStream&nbsp;stream)
               throws java.io.IOException</pre>
                                <div class="block">Write the raw data to an OutputStream.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>stream</code> - the OutputStream to which the data should be
                                        written.
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on problems writing to the specified
                                        stream.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setStartBlock-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setStartBlock</h4>
                                <pre>public&nbsp;void&nbsp;setStartBlock(int&nbsp;startBlock)</pre>
                                <div class="block">Set the start block for the document referred to by this
                                    Property.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>startBlock</code> - the start block index</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getStartBlock--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getStartBlock</h4>
                                <pre>public&nbsp;int&nbsp;getStartBlock()</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the start block</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getSize--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getSize</h4>
                                <pre>public&nbsp;int&nbsp;getSize()</pre>
                                <div class="block">find out the document size</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>size in bytes</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="shouldUseSmallBlocks--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>shouldUseSmallBlocks</h4>
                                <pre>public&nbsp;boolean&nbsp;shouldUseSmallBlocks()</pre>
                                <div class="block">Based on the currently defined size, should this property use
                                    small blocks?
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if the size is less than _big_block_minimum_bytes</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isSmall-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isSmall</h4>
                                <pre>public static&nbsp;boolean&nbsp;isSmall(int&nbsp;length)</pre>
                                <div class="block">does the length indicate a small document?</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>length</code> - length in bytes</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if the length is less than
                                        _big_block_minimum_bytes
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getName--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getName</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;getName()</pre>
                                <div class="block">Get the name of this property</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>property name as String</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isDirectory--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isDirectory</h4>
                                <pre>public abstract&nbsp;boolean&nbsp;isDirectory()</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if a directory type Property</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getStorageClsid--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getStorageClsid</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/hpsf/ClassID.html"
                                                    title="class in org.apache.poi.hpsf">ClassID</a>&nbsp;getStorageClsid()</pre>
                                <div class="block">Sets the storage clsid, which is the Class ID of a COM object which
                                    reads and writes this stream
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>storage Class ID for this property stream</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setName-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setName</h4>
                                <pre>protected&nbsp;void&nbsp;setName(java.lang.String&nbsp;name)</pre>
                                <div class="block">Set the name; silently truncates the name if it's too long.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>name</code> - the new name</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setStorageClsid-org.apache.poi.hpsf.ClassID-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setStorageClsid</h4>
                                <pre>public&nbsp;void&nbsp;setStorageClsid(<a
                                        href="../../../../../org/apache/poi/hpsf/ClassID.html"
                                        title="class in org.apache.poi.hpsf">ClassID</a>&nbsp;clsidStorage)</pre>
                                <div class="block">Sets the storage class ID for this property stream. This is the Class
                                    ID
                                    of the COM object which can read and write this property stream
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>clsidStorage</code> - Storage Class ID</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setPropertyType-byte-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setPropertyType</h4>
                                <pre>protected&nbsp;void&nbsp;setPropertyType(byte&nbsp;propertyType)</pre>
                                <div class="block">Set the property type. Makes no attempt to validate the value.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>propertyType</code> - the property type (root, file, directory)</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setNodeColor-byte-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setNodeColor</h4>
                                <pre>protected&nbsp;void&nbsp;setNodeColor(byte&nbsp;nodeColor)</pre>
                                <div class="block">Set the node color.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>nodeColor</code> - the node color (red or black)</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setChildProperty-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setChildProperty</h4>
                                <pre>protected&nbsp;void&nbsp;setChildProperty(int&nbsp;child)</pre>
                                <div class="block">Set the child property.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>child</code> - the child property's index in the Property Table</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getChildIndex--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getChildIndex</h4>
                                <pre>protected&nbsp;int&nbsp;getChildIndex()</pre>
                                <div class="block">Get the child property (its index in the Property Table)</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>child property index</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setSize-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setSize</h4>
                                <pre>protected&nbsp;void&nbsp;setSize(int&nbsp;size)</pre>
                                <div class="block">Set the size of the document associated with this Property</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>size</code> - the size of the document, in bytes</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setIndex-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setIndex</h4>
                                <pre>protected&nbsp;void&nbsp;setIndex(int&nbsp;index)</pre>
                                <div class="block">Set the index for this Property</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>index</code> - this Property's index within its containing
                                        Property Table
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getIndex--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getIndex</h4>
                                <pre>protected&nbsp;int&nbsp;getIndex()</pre>
                                <div class="block">get the index for this Property</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the index of this Property within its Property Table</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="preWrite--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>preWrite</h4>
                                <pre>protected abstract&nbsp;void&nbsp;preWrite()</pre>
                                <div class="block">Perform whatever activities need to be performed prior to
                                    writing
                                </div>
                            </li>
                        </ul>
                        <a name="getNextChild--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getNextChild</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/poifs/property/Child.html"
                                                    title="interface in org.apache.poi.poifs.property">Child</a>&nbsp;getNextChild()</pre>
                                <div class="block">Get the next Child, if any</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/property/Child.html#getNextChild--">getNextChild</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/property/Child.html"
                                                title="interface in org.apache.poi.poifs.property">Child</a></code></dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the next Child; may return null</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getPreviousChild--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getPreviousChild</h4>
                                <pre>public&nbsp;<a href="../../../../../org/apache/poi/poifs/property/Child.html"
                                                    title="interface in org.apache.poi.poifs.property">Child</a>&nbsp;getPreviousChild()</pre>
                                <div class="block">Get the previous Child, if any</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/property/Child.html#getPreviousChild--">getPreviousChild</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/property/Child.html"
                                                title="interface in org.apache.poi.poifs.property">Child</a></code></dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the previous Child; may return null</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setNextChild-org.apache.poi.poifs.property.Child-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setNextChild</h4>
                                <pre>public&nbsp;void&nbsp;setNextChild(<a
                                        href="../../../../../org/apache/poi/poifs/property/Child.html"
                                        title="interface in org.apache.poi.poifs.property">Child</a>&nbsp;child)</pre>
                                <div class="block">Set the next Child</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/property/Child.html#setNextChild-org.apache.poi.poifs.property.Child-">setNextChild</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/property/Child.html"
                                                title="interface in org.apache.poi.poifs.property">Child</a></code></dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>child</code> - the new 'next' child; may be null, which has the
                                        effect of saying there is no 'next' child
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setPreviousChild-org.apache.poi.poifs.property.Child-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setPreviousChild</h4>
                                <pre>public&nbsp;void&nbsp;setPreviousChild(<a
                                        href="../../../../../org/apache/poi/poifs/property/Child.html"
                                        title="interface in org.apache.poi.poifs.property">Child</a>&nbsp;child)</pre>
                                <div class="block">Set the previous Child</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/property/Child.html#setPreviousChild-org.apache.poi.poifs.property.Child-">setPreviousChild</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/property/Child.html"
                                                title="interface in org.apache.poi.poifs.property">Child</a></code></dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>child</code> - the new 'previous' child; may be null, which has
                                        the effect of saying there is no 'previous' child
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getViewableArray--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getViewableArray</h4>
                                <pre>public&nbsp;java.lang.Object[]&nbsp;getViewableArray()</pre>
                                <div class="block">Get an array of objects, some of which may implement
                                    POIFSViewable
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html#getViewableArray--">getViewableArray</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                                                title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>an array of Object; may not be null, but may be empty</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getViewableIterator--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getViewableIterator</h4>
                                <pre>public&nbsp;java.util.Iterator&lt;java.lang.Object&gt;&nbsp;getViewableIterator()</pre>
                                <div class="block">Get an Iterator of objects, some of which may implement
                                    POIFSViewable
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html#getViewableIterator--">getViewableIterator</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                                                title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>an Iterator; may not be null, but may have an empty
                                        back end store
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="preferArray--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>preferArray</h4>
                                <pre>public&nbsp;boolean&nbsp;preferArray()</pre>
                                <div class="block">Give viewers a hint as to whether to call getViewableArray or
                                    getViewableIterator
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html#preferArray--">preferArray</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                                                title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if a viewer should call getViewableArray, false if
                                        a viewer should call getViewableIterator
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getShortDescription--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>getShortDescription</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;getShortDescription()</pre>
                                <div class="block">Provides a short description of the object, to be used when a
                                    POIFSViewable object has not provided its contents.
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html#getShortDescription--">getShortDescription</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                                                title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>short description</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/Property.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/property/Parent.html"
               title="interface in org.apache.poi.poifs.property"><span class="typeNameLink">Prev&nbsp;Class</span></a>
        </li>
        <li><a href="../../../../../org/apache/poi/poifs/property/PropertyConstants.html"
               title="interface in org.apache.poi.poifs.property"><span class="typeNameLink">Next&nbsp;Class</span></a>
        </li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/property/Property.html" target="_top">Frames</a>
        </li>
        <li><a href="Property.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
